<template>
  <section class="section">
    <h2 class="text-center my-4">
      Data Filtering
    </h2>

    <p class="my-8">
      This platform allows us to work on voting data. This data is compound of:
      <ol>
        <li>a collection of ballots featuring all ballots characterized by several descriptive attributes (e.g. date, topic…)</li> and <li>a collection of voters which are also characterized by several descriptive attributes (e.g. name, party…).</li>
      </ol>
      <br>
      This first step consists in selecting a <em class="keyword">study
        group</em> of voters in which the mining algorithm in order to highlight
      potentially significant change of agreement between voters.
    </p>

    <div class="my-4">
      <GroupWithRules
        v-model="contexts_scope"
        class="box p-4"
        :rows="contextData"
        :columns="contextTableColumns"
        :dimensions="contextColumns"
      >
        <em class="keyword">Contexts search perimeter</em> (ballots)
      </GroupWithRules>
    </div>

    <div class="flex flex-col md:flex-row my-4">
      <GroupWithRules
        v-model="individuals_scope"
        class="box md:w-2/5 p-4"
        :rows="userData"
        :columns="userTableColumns"
        :dimensions="userColumns"
      >
        <em class="keyword">Study Group</em>
      </GroupWithRules>

      <div class="flex flex-col flex-grow justify-center m-4">
        <div class="text-center">
          I am looking for
        </div>

        <p class="text-center">
          between those two groups, with a
        </p>

        <p class="text-center">
          <span class="text-xl">
            minimum agreement change
          </span>
          of
          <b class="text-xl">
            {{ threshold_quality }}
          </b>
        </p>

        <div class="text-center">
          <LogarithmicRange
            v-model.number="threshold_quality"
            placeholder="Threshold over the quality measure"
            class="w-full"
          />
          <div class="flex justify-between text-xs">
            <p class="text-left">
              less intense change
            </p>
            <p class="text-right">
              more intense change
            </p>
          </div>
        </div>
      </div>
    </div>

    <hr class="border-b my-8">

    <div class="my-8">
      <h2 class="text-center">
        Analysis Dimensions
      </h2>

      <p class="my-4">
        To enable the discovery of interprettable patterns, the platform offers
        the possibility to the user to choose which dimensions worth to be
        considered to highlight conflictual/consensual (depending on the desired
        query in the first step) situations in the votes.
      </p>
      <p class="my-4">
        In a nutshell, the left box allows to determine what are the dimensions
        that may appear to describe a conflictual/consensual
        situation <em class="keyword">context</em> (characterizing a subset of
        ballots), and the right box offer the possibility to determine the
        dimensions that may appear to describe a subset of voters considering
        exclusively the <em class="keyword">study group</em> in the first step
        (Data Filtering).
      </p>

      <p class="italic text-center my-4">
        Drop the attributes in the boxes to use them.
      </p>

      <div class="lg:grid-half">
        <div class="box bg-white p-4 w-full mb-4 lg:mb-0">
          <h5 class="text-center mb-4">
            Selected dimensions for ballots
          </h5>

          <p class="italic mb-4">
            Which dimensions to use to characterize collections of ballots?
          </p>

          <DimensionsSelector
            v-model="contextSelectedColumns"
            group="context"
            :selectable-items="dataset.selectableContextColumns"
            :img="require('@/assets/ballot_box.svg')"
            class="md:grid-half text-sm"
          />

        </div>

        <div class="box bg-white p-4 w-full">
          <h5 class="text-center mb-4">
            Selected dimensions for voters
          </h5>

          <p class="italic mb-4">
            Which dimensions to use to characterize a group of voters?
          </p>

          <DimensionsSelector
            v-model="userSelectedColumns"
            group="user"
            :selectable-items="dataset.selectableUserColumns"
            :img="require('@/assets/pawn.svg')"
            class="md:grid-half text-sm"
          />
        </div>
      </div>
    </div>

    <hr class="border-b my-8">

    <collapse
      class="box my-4"
      :open="false"
    >
      <template v-slot:toggle>
        <div
          class="p-4 cursor-pointer"
        >
          <h4 class="mb-4">
            ⚙ JSON file (Detailed Execution Properties File)
          </h4>

          <p class="italic mb-4">
            Save all the parameters in a file, or load an existing one.
          </p>

          <div
            class="flex flex-col sm:flex-row items-center"
          >
            <a
              class="btn w-full sm:w-32 mb-4 sm:mb-0 sm:mr-4 no-underline text-black"
              :href="exportSettings"
              download="settings.json"
            >
              Export
            </a>

            <label class="btn w-full sm:w-32">
              Import
              <ImportFile
                class="opacity-0 overflow-hidden absolute w-px h-px"
                @load="importSettings(JSON.parse($event))"
              />
            </label>
          </div>
        </div>
      </template>

      <div class="bg-white p-4">
        <SettingsJSON
          :json="json"
        />
      </div>
    </collapse>

    <collapse
      class="box"
      :open="false"
    >
      <template v-slot:toggle>
        <div
          class="p-4 cursor-pointer"
        >
          <h4 class="">
            ⚙ Advanced tools
          </h4>
        </div>
      </template>

      <div class="bg-white p-4">
        <div class="flex items-center my-2">
          <label class="mr-2">
            Minimum size of a collection of ballots
          </label>
          <input
            v-model.number="threshold_objects"
            class="w-16 border"
            type="number"
            placeholder="Threshold over the size of the object subgroup"
            min="1"
          >
        </div>

        <div class="flex items-center my-2">
          <label class="mr-2">
            Minimum size of a group of parliamentarians
          </label>
          <input
            v-model.number="threshold_individuals"
            type="number"
            class="border w-16"
            placeholder="Threshold over the size of the users subgroup"
            min="1"
          >
        </div>

        <div class="my-2">
          <label class="">
            Algorithm
          </label>
          <select
            v-model="algorithm"
            class="select"
          >
            <option
              v-for="f of algorithms"
              :key="f.value"
              :value="f"
            >
              {{ f.label }}
            </option>
          </select>
        </div>

        <div class="my-2">
          <label>
            compute_bootstrap_ci
          </label>
          <input
            v-model="compute_bootstrap_ci"
            type="checkbox"
          >
        </div>
      </div>
    </collapse>
  </section>
</template>

<script lang="ts">
import { Vue, Component, Mixins, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/clone'
import Icon from 'vue-awesome/components/Icon.vue'

import ConfigMixin from '@/mixins/Config.ts'

import Collapse from '@/components/Collapse.vue'
import DragList from '@/components/DragList.vue'
import DimensionsSelector from '@/components/DimensionsSelector.vue'
import GroupWithRules from '@/components/ConfigGroupWithRules.vue'
import ImportFile from '@/components/ImportFile.vue'
import LogarithmicRange from '@/components/LogarithmicRange.vue'
import SettingsJSON from '@/components/SettingsJSON.vue'

import _ from 'lodash/fp'

function createJSON (vm) {
  return {
    dataset: vm.dataset,
    configType: 'intra',

    delimiter: '\t',

    nb_objects: 50000,
    nb_individuals: 50000,

    arrayHeader: vm.settings.arrayHeader,
    numericHeader: vm.settings.numericHeader,
    vector_of_outcome: null, // Fixed for now

    description_attributes_objects: vm.description_attributes_objects,
    description_attributes_individuals: vm.description_attributes_individuals,

    threshold_objects: vm.settings.threshold_objects,
    threshold_individuals: vm.settings.threshold_individuals,
    threshold_quality: vm.settings.threshold_quality,

    compute_bootstrap_ci: vm.compute_bootstrap_ci,

    algorithm: _.get('value', vm.algorithm),
    outcome_distance_function: 'categorical',
    ratings_to_remove: [],
    ratings_to_remove_NO_ABSTAIN: ['Abstain'],

    timebudget: 3600,

    objects_scope: [],

    contexts_scope: vm.contexts_scope,
    individuals_scope: vm.individuals_scope
  }
}

@Component({
  components: {
    Collapse,
    DimensionsSelector,
    GroupWithRules,
    Icon,
    ImportFile,
    LogarithmicRange,
    SettingsJSON
  }
})
export default class ConfigIntra extends Mixins(ConfigMixin) {
  qual_functions = [
    {
      label: 'BOTH',
      value: 'BOTH'
    }
  ]

  algorithms = [
    {
      label: 'P_VALUE_PEERS',
      value: 'P_VALUE_PEERS'
    }
  ]

  get json () {
    return createJSON(this)
  }

  get compute_bootstrap_ci () {
    return this.settings.compute_bootstrap_ci || false
  }

  set compute_bootstrap_ci (compute_bootstrap_ci) {
    this.$store.commit('SET_SETTINGS', { compute_bootstrap_ci })
  }

  get algorithm () {
    return _.find(_.matchesProperty('value')(this.settings.algorithm), this.algorithms) || _.first(this.algorithms)
  }

  set algorithm (algo) {
    const algorithm = algo.value
    this.$store.commit('SET_SETTINGS', { algorithm })
  }

  get individuals_scope () {
    return this.settings.individuals_scope || []
  }

  set individuals_scope (individuals_scope: number) {
    this.$store.commit('SET_SETTINGS', { individuals_scope })
  }
}
</script>
